#ifndef __SCRIPTS_HPP__
#define __SCRIPTS_HPP__

#include <lua.hpp>
#include <set>
#include "triangulate.hpp"

void luaInitialize();
double coinGetField(int coin, char* field);
double lua_getField(char* tableName, int index, char* field);
int coinGetNum();
double getLuaParam(char* name);
void luaStep();
void importParamsFromLua(int i);
int exportParamsToLua(int i);
std::set<int> luaGetCoinKeys();
static int lua_hitTest(lua_State *L);
int lua_createZone(lua_State *L);
int lua_createCoin(lua_State *L);
int lua_queryZone(lua_State *L);
int lua_syncZones(lua_State *L);
Vector2dVector lua_triangulate();
std::set<int> lua_getKeys(char* targetTable);

std::pair<short,short> lua_getScore ();


#endif
